
/*
 *  I have tried to isolate all of the system dependent includes in this
 *  file.  To port Alex to another Unix system probably will take some
 *  changes to this file.  If you make such changes please do them please
 *  ifdef them with your system type and then send me in the diffs so the 
 *  next person will not have to port it.  
 *
 *  Thanks,
 *           -- Vince
 *              vac@cs.cmu.edu
 */

#ifdef __alpha
#define ALPHAOSF
#endif

#include <stdio.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <strings.h>
#include <ctype.h>
#include <sys/param.h>

#if !defined(ultrix) && !defined(__386BSD__) && !defined(ALPHAOSF) && !defined(__NetBSD__)
#  include <sys/vfs.h>
#endif

#include <sys/time.h>
#include <sys/timeb.h>

#if defined(ultrix) || defined(ALPHAOSF)
#  include <netinet/in.h>       /* needs to be before rpc/*.h and nfs/*.h */
#  include <ufs/fs.h>
#  include <rpc/types.h>
#  include <malloc.h>
#endif

#ifdef ultrix
   extern double rint();        /* for some reason this isn't in math.h */
#  include <sys/mount.h>
#  include <nfs/nfs_clnt.h>
#  include <nfs/vfs.h>
#else
#  ifdef MACH
#  include <sys/inode.h>              /*  ufs/inode.h on many machines */
#  include <sys/fs.h>                 /*  ufs/fs.h  on many machines */
   extern char *malloc();             /*  seems there is no malloc.h */
   extern char *realloc();
#else
#  ifdef __linux__
#  include <malloc.h>
#  else

#    if defined(__386BSD__) || defined(__NetBSD__)
#      include <sys/uio.h>
#      include <sys/proc.h>
#      include <sys/ucred.h>
#      include <ufs/quota.h>
#    endif
#    include <sys/vnode.h>
#    ifdef hpux
#      include <sys/inode.h>
#      include <sys/fs.h>
#    else
#      include <ufs/inode.h>
#      include <ufs/fs.h>
#    endif
#    if defined(__386BSD__) || defined(__NetBSD__)
#      include <sys/malloc.h>
#    else
#      ifndef NeXT
#          include <malloc.h> /* Next arpa name server file includes */
#      endif                  /* some conflicting definitions        */
#    endif
#  endif
#endif
#endif

#include <signal.h>
#include <netdb.h>
#include <arpa/nameser.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <resolv.h>
#include <sys/socket.h>
#include <pwd.h>
#if !defined(ultrix) && !defined(__386BSD__) && !defined(ALPHAOSF) && !defined(__NetBSD__)
#  include <mntent.h>
#endif

#include <sys/dir.h>
#include <math.h>
#ifdef hpux
#define rint(x) (floor(x + 0.5))
#endif

#include <sys/ioctl.h>
#include <varargs.h>


/* ftpparent ftp child stuff */
#include <string.h>
#include <arpa/ftp.h>
#include <arpa/telnet.h>

/* unfsd and unfsmntd stuff */
#include <sys/file.h>
#include <syslog.h>
#include <rpc/rpc.h>


#ifdef __NetBSD__
#include <sys/mount.h>
#endif


