#include <stdio.h>
#include <ctype.h>


/*
 *  Input string with space separated tokens
 *  copy Nth token into token (first token is token 0)
 *  Return pointer to space or 0 that terminated the token
 */
char *GetNthToken(s, n, token)
char *s;
int n;
char *token;
{
    int i;

    if (s == NULL) {
        fprintf(stderr, "ERROR GetNthToken should never get a null pointer");
        if (token!=NULL) {
            *token=0;                               /* terminate token */
        }
        return(NULL);
    }

    while((*s != 0) && isspace(*s)) {       /* skip leading spaces if any */
        s++;
    }

    for (i=0; i<n; i++) {                      /* skip n tokens */
        while((*s != 0) && !isspace(*s))       /* skip a token  */
            s++;
        while((*s != 0) && isspace(*s))        /* skip spaces */
            s++;
    }
    for (; (*s != 0)   && (!(isspace(*s))) ; s++) {      /* copy token only */
        *token = *s;
         token++;
    }
    *token=0;                               /* terminate token     */
    return(s);                              /* so we coult start up again wherewe left off */
}

/*
 *   copy the next non-space stuff in s to token
 *   The return value is a pointer to the space after this token
 */

char *GetNextToken(s, token)
char *s, *token;
{
    return(GetNthToken(s, 0, token));
}

int CountOccurances(s, c)
char *s, c;
{
    int Result;

    if (s==NULL) return(0);

    for( Result=0; (*s != 0); s++) {
        if (*s == c) Result++;
    }
    return(Result);
}


/* simple to start with */
int LooksLikeHostName(token)
char *token;
{
    if (CountOccurances(token, '.') > 2) {
        return(1);
    } else {
        return(0);
    }
}


main()
{
    char line[500];   
    char Token[500];
    char *s;

    while (gets(line) != NULL) { 
        s=line; 
        s=GetNextToken(s,Token);
        while (*Token != 0) {
            if (LooksLikeHostName(Token)) {
                printf("%s\n", Token);
            }
            s=GetNextToken(s,Token);
        }
    }
}

