

/* for each component in the name we may need to make a directory.

   Since we got the file ok we know the intermediate directories do exist.

 */


#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <sys/stat.h>

char *malloc();

int pid;
#define execl2  pid=fork(); if (pid==0) execl

/* copies at most num parts of a path from from to to 
 */
int copyNparts(to, from, num)
char *to, *from;
int num;
{
    int numcopied;

    for (numcopied=0; (numcopied<num) && (*from != NULL); ) {
        *to++=*from++;    
        if ((*from == '/') || (*from == NULL)) { 
            numcopied++;
        }
    }
    *to=NULL;
}


int countdirs(path)
char *path;
{
    int result;
    
    for(result=0; *path != NULL; path++) {
       if (*path == '/') {  
           result++;
       }
    }
    result--;                   /* don't count file, just dirs */
    return(result);
}

/* 
 *  #define    S_IFDIR       0040000/* directory 
 *  The status information word st_mode has bits:
 *   struct stat { [...]     u_short  st_mode;    [...] };
 *
 *  Today's algorithm:     Work from top down.
 *
 *  Future: Stat directory above file:
 *     if that is there, then return
 *     else top down
 *  XXXXXXXXXXX not enough error checking yet
 */

int CheckIntermediateDirs(path)
char *path;
{
     char subpath[500];
     struct stat *buf;
     int parts, numparts, returnstat;
     int mode;
    
     mode=0777;

     numparts=countdirs(path);
 
     for (parts=1; parts<=numparts ; parts++ ) {
         copyNparts(subpath, path, parts);
         returnstat = stat(subpath, buf);
         if (returnstat != 0) {
             mkdir(subpath, mode);
         } else {
             if ((buf->st_mode & S_IFDIR) == 0) {
                  unlink(subpath);                      /* get rid of file that should be dir */
                  mkdir(subpath, mode);
             }
         }
     }
}


int Copy(path)
char *path;
{
    FILE *from, *to;

    from=fopen("tmp", "r");
    to=fopen(path, "w");
    if ((from !=NULL) && (to != NULL)) {
        if(ffilecopy(from,to) !=0) {
            fprintf(stderr, "Could not copy tmp to %s \n",path);
        }
    } else {
       fprintf(stderr, "Could not open files for copy to %s \n",path);
    }
}


main(argc, argv)
int argc;
char **argv;
{
        char *localpathname;

        if (argc < 1) {
              fprintf(stderr,"usage: mkdirscopy local/path/name \n");
              exit(-1);
        }

        localpathname=malloc((unsigned) (strlen(argv[1])+2));
        strcpy(localpathname, argv[1]);

        execl2("addtolog", "addtolog", "ftpit.log", "mkdirscopy  ", localpathname, "\n", 0);

        CheckIntermediateDirs(localpathname);
        Copy(localpathname);
}


